package org.ts.ddcs.DataItemTemplate;

import org.ts.ddcs.Entity.RsvrEntity;
import org.ts.ddcs.Log.LogHelper;
import org.ts.ddcs.Tool.BytesHelp;
import org.ts.ddcs.Tool.StringUtil;

import java.math.BigDecimal;

/**
 * 3A
 * 库（闸、站）下水位
 */
@SuppressWarnings("all")
public class DataItemTemplateZB extends DataItemTemplate {
    @Override
    public byte[] Stream(byte[] data) {
        byte[] remain = data;
        try {
            if (this.macth) {
                return remain;
            }
            int count = 0;
            String flag = BytesHelp.byte2HexStr(remain, count, 1);
            count += 1;
            if (flag.equals(this.feture)) {
                byte[] len = BytesHelp.subBytes(remain, count, 1);
                count += 1;
                int dataTotalLen = len[0] >> 3;
                int decimalLen = len[0] & 7;
                byte[] buff = BytesHelp.subBytes(remain, count, dataTotalLen);
                count += dataTotalLen;
                boolean dataError = true;
                for (int i = 0; i < dataTotalLen; i++) {
                    if (buff[i] != (byte) 0xFF) {
                        dataError = false;
                        break;
                    }
                }
                String hexStr = BytesHelp.byte2HexStr(buff);
                if (!dataError) {
                    StringBuffer dataStr = new StringBuffer(hexStr);
                    if (decimalLen != 0) {
                        dataStr.insert(dataStr.length() - decimalLen, ".");
                    }
                    String value = StringUtil.getPrettyNumber(dataStr.toString());
                    this.bigDecimalValue = new BigDecimal(value);
                } else {
                    LogHelper.info(this.desc + ":" + this.feture + ":" + "数据异常");
                }
                remain = BytesHelp.subBytes(remain, count, remain.length - count);
                this.macth = true;
            }
        } catch (Exception e) {
            LogHelper.error(e);
        }
        return remain;
    }

    @Override
    public void SetEntity(Object entity) {
        RsvrEntity rsvrEntity = (RsvrEntity) entity;
        rsvrEntity.setBLRZ(this.bigDecimalValue);
    }
}
